<?php

// Nom du fichier d'archive à créer
$archiveName = 'archive_site_' . date('Y-m-d') . '.zip';

// Initialisation du compteur de fichiers
$fileCount = 0;

// Création d'une nouvelle instance de ZipArchive
$zip = new ZipArchive();

// Ouverture de l'archive pour l'ajout de fichiers
if ($zip->open($archiveName, ZipArchive::CREATE) === TRUE) {
    // Fonction récursive pour ajouter tout le contenu du répertoire courant à l'archive
    addFolderToZip(".", $zip, $fileCount);
    // Fermeture de l'archive
    $zip->close();
    echo "L'archive $archiveName a été créée avec succès.\n";
} else {
    echo "Erreur lors de la création de l'archive.\n";
}

function addFolderToZip($folder, &$zipInstance, &$fileCount, $subfolder = '') {
    $handle = opendir($folder);
    while (($f = readdir($handle)) !== false) {
        if ($f != '.' && $f != '..') {
            $filePath = "$folder/$f";
            if (is_file($filePath)) {
                $zipInstance->addFile($filePath, $subfolder . $f);
                $fileCount++;
                // Affichage d'un message tous les 1000 fichiers traités
                if ($fileCount % 100 == 0) {
                    echo "Nombre de fichiers traités : $fileCount\n";
                }
            } elseif (is_dir($filePath)) {
                addFolderToZip($filePath, $zipInstance, $fileCount, $subfolder . $f . '/');
            }
        }
    }
    closedir($handle);
}

?>